package Win32API::Wow64FsRedirection;

use strict;
use warnings;
#use feature qw( state );

use Exporter   qw( import );
use Win32::API qw( );

our @EXPORT_OK = qw( Wow64Disable Wow64Revert system64);
our %EXPORT_TAGS = ( ALL => \@EXPORT_OK );


# On success, returns value to pass to Wow64Revert. This value will be true.
# On error, returns false and sets $^E.
sub Wow64Disable {
    my $Wow64DisableWow64FsRedirection = Win32::API->new(
      'kernel32', 'Wow64DisableWow64FsRedirection', 'P', 'L',
   );

   my $OldValue_buf = pack('L', 0);

   $Wow64DisableWow64FsRedirection->Call($OldValue_buf)
      or return undef;

   return unpack('L', $OldValue_buf) || "0 but true";
}


# On success, returns true.
# On error, returns false and sets $^E.
sub Wow64Revert {
   my ($OldValue) = @_;

    my $Wow64RevertWow64FsRedirection = Win32::API->new(
      'kernel32', 'Wow64RevertWow64FsRedirection', 'N', 'L',
   );

   return $Wow64RevertWow64FsRedirection->Call($OldValue);
}

sub system64
{
	my @Command=@_;
        my $Ret;
	my $saved = Wow64Disable() or die("Wow64Disable: $^E\n");
	$Ret=system(@Command);
	Wow64Revert($saved) or die("Wow64Revert: $^E\n");
	return $Ret;
}

#exmple of use
#use Win32API::Wow64FsRedirection qw( :ALL );

#my $saved = Wow64Disable() or die("Wow64Disable: $^E\n");
#system('echo %PROCESSOR_ARCHITECTURE%');
#Wow64Revert($saved) or die("Wow64Revert: $^E\n");

#system64('echo %PROCESSOR_ARCHITECTURE%');
1;