
#################################################################################
#
#  Licensed Materials - Property of IBM
#  Restricted Material of IBM
#  IBM Rational Test RealTime
#  (c) Copyright IBM Corp. 2003-2007 All Rights Reserved.
#
#  US Governement Users Restricted Rights - Use, duplication or
#  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
#
#################################################################################
# this script is assumed to be executed on Unix/Linux machine only to choose the apropriate gnu xdp to generate cgnu TDP

use File::Basename;
use File::Copy;

die "Environment variable TESTRTDIR not found. Exiting.\n" if(!defined($ENV{'TESTRTDIR'})); # NO TRANSLATION
$SCRIPTDIR="$ENV{'TESTRTDIR'}/lib/scripts/";
require $SCRIPTDIR . "Translate.pl";
require $SCRIPTDIR . "rsfGetInput.pl";

$ENV{LC_MESSAGES}='C'; #to get the gcc message without any localization
$ENV{LC_ALL}='C'; #to get the gcc message without any localization
my $INTDIR=".";
my $pathSeparator;
my $gcc_dir;
my $gcc_version;
my $silent=0;

sub quit
{
	print &PerlTranslate("ConfigureGcc.pl", "\nConfiguration is not complete.\n");
	print &PerlTranslate("ConfigureGcc.pl", "You can relaunch this configuration script later by using the command:\n");
	print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureGcc.pl\nor\nConfigureGcc.sh\n"; # NO TRANSLATION
	print &PerlTranslate("ConfigureGcc.pl", "Confirm quit ? ( y | n )\n");
	$reply='y';
	#$reply=<STDIN>;
	$reply=&rsfGetInput('gcc_configure_confirm_quit','') unless($silent);#no default- use for silent install
	chomp($reply);
	if(($reply eq &PerlTranslate("ConfigureGcc.pl", "y"))||($reply eq &PerlTranslate("ConfigureGcc.pl", "yes")))
	{
		print &PerlTranslate("ConfigureGcc.pl", "Quitting\n");
		exit(1);
	}
}

sub showLog #($)
{
	my $log=shift;

	open(IN,"<$log");
	while(<IN>) { print ; }
	close(IN);
}

sub MCheckGcc
{
	my $Status;
	my $gcccmd;
	my $tmp="$INTDIR/tmp_gcc_v";
	my $confirm;

	$confirm=0;
	while($confirm==0)
	{
		$Status=1;
		while($Status!=0)
		{
			$gcccmd="gcc" if($gcc_dir eq "");
			$gcccmd="$gcc_dir/gcc" if($gcc_dir ne "");
			print &PerlTranslate("ConfigureGcc.pl", "Trying to execute %1\n", "%1 is the command to be executed", "$gcccmd -v");
                        $back_lang = $ENV{'LANG'};
                        $ENV{'LANG'} = "C";
			$Status=system("$gcccmd -v > $tmp 2>&1");
                        $ENV{'LANG'} = $back_lang;
			$Status>>=8 if($^O=~/Win32/);
			if($Status!=0)
			{
				print &PerlTranslate("ConfigureGcc.pl", "The return status was %1\n", "%1 is the status", $Status);
				print &PerlTranslate("ConfigureGcc.pl", "The command %1 does not work properly: Here is the log file:\n", "%1 is the command", $gcccmd);
				showLog($tmp);
				print &PerlTranslate("ConfigureGcc.pl", "\nEnter the complete name of the directory containing gcc or q to quit\n");

				#$gcc_dir=<STDIN>;
				$gcc_dir=&rsfGetInput('gcc_complete_path','') unless($silent);#no default - use for silent install

				chomp($gcc_dir);
				if($gcc_dir eq &PerlTranslate("ConfigureGcc.pl", "q"))
				{
					quit();
					$gcc_dir="";
				}
			}
		}
		#
		# Show the log
		#
		print &PerlTranslate("ConfigureGcc.pl", "Obtained following result:\n");
		showLog($tmp);
		print &PerlTranslate("ConfigureGcc.pl", "\nIs this correct ? ( y | n )\n");
		$reply='y';
		#$reply=<STDIN>;
		$reply=&rsfGetInput('gcc_confirm_path','') unless($silent);#no default - use for silent install

		chomp($reply);
		$confirm=1 if(($reply eq &PerlTranslate("ConfigureGcc.pl", "y"))||($reply eq &PerlTranslate("ConfigureGcc.pl", "yes")));
		if(($reply ne &PerlTranslate("ConfigureGcc.pl", "y"))&&($reply ne &PerlTranslate("ConfigureGcc.pl", "yes")))
		{
			print &PerlTranslate("ConfigureGcc.pl", "\nEnter the complete name of the directory containing gcc or q to quit\n");

			#$gcc_dir=<STDIN>;
			$gcc_dir=&rsfGetInput('gcc_complete_path','') unless($silent);#no default - use for silent install

			chomp($gcc_dir);
			if($gcc_dir eq &PerlTranslate("ConfigureGcc.pl", "q"))
			{
				quit();
				$gcc_dir="";
			}
		}
		else
		{
			my $found=0;
			open(GCC,"<$tmp");
			while(<GCC>)
			{
				if (/^(.*) version (?:egcs-)?((\d+\.)+\d+).*$/)
				{
					$gcc_version = $2;
					$found = 1;
					break;
				}
			}
			close(GCC);
			if($found==0)
			{
				print &PerlTranslate("ConfigureGcc.pl", "Can not parse to find out the gnu version - Try again\n");
				print &PerlTranslate("ConfigureGcc.pl", "\nEnter the complete name of the directory containing gcc or q to quit\n");
				$gcc_dir='q';
				#$gcc_dir=<STDIN>;
				$gcc_dir=&rsfGetInput('gcc_complete_path','') unless($silent);#no default - use for silent install

				chomp($gcc_dir);
				if($gcc_dir eq &PerlTranslate("ConfigureGcc.pl", "q"))
				{
					quit();
					$gcc_dir="";
				}
			}
		}
	}
	print &PerlTranslate("ConfigureGcc.pl", "Trying to C compile\n");
	$ENV{'PATH'}=$gcc_dir.$pathSeparator.$ENV{'PATH'} if($gcc_dir ne "");
	open(OU,">$INTDIR/empty.c"); print OU "int main() { return(0); }\n"; close(OU);
	$Status=system("gcc -v $INTDIR/empty.c > $tmp 2>&1");
	if($Status != 0)
	{
		print &PerlTranslate("ConfigureGcc.pl", "The return status was %1\n", "%1 is the status", $Status);
		print &PerlTranslate("ConfigureGcc.pl", "%1 produced the following results\n", "%1 is the command that has been launched", "gcc -v $INTDIR/empty.c");
		showLog($tmp);
		print &PerlTranslate("ConfigureGcc.pl", "\nConfiguration is not complete.\n");
		print &PerlTranslate("ConfigureGcc.pl", "Please solve the problem with the gnu compiler. Contact your system administrator if necessary.\n");
		print &PerlTranslate("ConfigureGcc.pl", "You can relaunch this configuration script later by using the command:\n");
		print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureGcc.pl\nor\nConfigureGcc.sh\n"; # NO TRANSLATION
		exit(1);

	}
	print &PerlTranslate("ConfigureGcc.pl", "Success\n");
	copy("$INTDIR/empty.c","$INTDIR/empty.cc");
	print &PerlTranslate("ConfigureGcc.pl", "Trying to C++ compile\n");
	$Status=system("g++ -v $INTDIR/empty.c > $tmp 2>&1");
	if($Status != 0)
	{
		print &PerlTranslate("ConfigureGcc.pl", "The return status was %1\n", "%1 is the status", $Status);
		print &PerlTranslate("ConfigureGcc.pl", "%1 produced the following results\n", "%1 is the command that has been launched", "g++ -v $INTDIR/empty.c");
		showLog($tmp);
		print &PerlTranslate("ConfigureGcc.pl", "\nConfiguration is not complete.\n");
		print &PerlTranslate("ConfigureGcc.pl", "Please solve the problem with the gnu compiler. Contact your system administrator if necessary.\n");
		print &PerlTranslate("ConfigureGcc.pl", "You can relaunch this configuration script later by using the command:\n");
		print "$BINDIR/TestRTperl -I$ENV{'TESTRTDIR'}/lib/perl ConfigureGcc.pl\nor\nConfigureGcc.sh\n"; # NO TRANSLATION
		exit(1);
	}
	print &PerlTranslate("ConfigureGcc.pl", "Success\n");
	unlink("$INTDIR/empty.c");
	unlink("$INTDIR/empty.cc");
	unlink("$INTDIR/a.out");
	unlink($tmp);
	return($found);
}

sub patchXdp #($$$)	patchXdp("$xmlDir/$orgxdp","$xmlDir/$xdpFile",$gcc_dir,$patch64);
{
	my $orgxdp=shift;
	my $newxdp=shift;
	my $path=shift;
	my $patch64=shift;

	my $pathmet;
	my $beforeComment=1;
	my $inOpp=0;
	my $insizet=0;
	print &PerlTranslate("ConfigureGcc.pl", "Patching %1\n", "%1 is the file to be patched", $newxdp);
	print &PerlTranslate("ConfigureGcc.pl", "Patching with gcc PATH as %1\n", "%1 is the value for the gcc PATH", $path) if($path);
	print &PerlTranslate("ConfigureGcc.pl", "Patching %1 for 64bits machine\n", "%1 is the file to be patched",$newxdp) if($patch64);
	$pathmet=0;
	open(IN,"<$orgxdp");
	open(OU,">$newxdp");
	while(<IN>)
	{
		if(/^<TDP\s/) #change the TDP name to 'GNU'
		{
#			s/(Name=\"[^\"]*Gnu) [^\"]*\"/$1\"/;
			s/Name=\"[^\"]*\"/Name=\"GNU\"/;
		}
		elsif($beforeComment && /<COMMENT>/)
		{
			print OU "<COMMENT>xdp automatically generated based on $orgxdp\n";
			print OU "include modification for 64bits platform\n" if($patch64);
			s/<COMMENT>(.*)$/$1/;
			$beforeComment=0;
		}
		#modify the PATH to access gcc
		elsif(/<KEY>ENV_PATH<\/KEY>/)
		{
			$pathmet=1 if($path ne "");
		}
		elsif($pathmet==1)
		{
			s/<VALUE>.*<\/VALUE>/<VALUE>$path:\$ENV{'PATH'}<\/VALUE>/;
			$pathmet=0;
		}
		elsif($patch64) {
			#changes for 64bits machine
			if(/RTRT_64_BITS_PTR/) {
				s/Value=\"0\"/Value=\"1\"/;
			}
			elsif(/VALUE>\(\(RTRT_U_INT32\)p\)<\/VALUE/){
				s,VALUE>\(\(RTRT_U_INT32\)p\)<\/VALUE,VALUE>((RTRT_U_INT64)p)<\/VALUE,;
			}
			#change the RTRT_SIZE_T type
			elsif(/SIZET/) {
				$insizet=1;
			}
			elsif($insizet && /<VALUE>/) {
				$insizet=0;
				s/<VALUE>unsigned\s+int</<VALUE>unsigned long</;
			}
			#change options in atl.opp
			elsif(/<PCOPP /) {
				$inOpp=1;
			}
			elsif($inOpp && /(targ_size_t_int_kind\s+(\d+))/) {
				print OU "--diag_suppress 61,69\n";
				s/$1/targ_size_t_int_kind 8/;
				$inOpp=0;
			}
			elsif($inOpp && /<\/VALUE>/) {
				$inOpp=0;
				print OU "--diag_suppress 61,69\n";
				print OU "--targ_size_t_int_kind 8\n";
			}
		}

		print OU;
	}
	close(IN);
	close(OU);
}

sub main
{
	my $xdpFile="cgnu.xdp"; #xdp to generate
	my $perl;
	my $outTargetsDir="$ENV{'TESTRTDIR'}/targets";
	my $xmlDir="$outTargetsDir/xml";
	my $outXmlDir=$xmlDir;
	my $orgxdp;

	die &PerlTranslate("ConfigureGcc.pl", "Environment variable TESTRTDIR not properly set. Cannot find targets directory. Exiting.\n") if(! -d "$ENV{'TESTRTDIR'}/targets");
	$pathSeparator=":";
#	$pathSeparator=";" if($^O=~/Win32/);
	foreach my $arg (@ARGV) {
		if($arg=~/silent$/) {
			$silent=1;
		}elsif(-d $arg){
			$outTargetsDir=$arg;
			$outXmlDir="$outTargetsDir/xml";
			mkdir( $outXmlDir, 0777) unless(-d $outXmlDir);
		}
	}

	if($^O =~ /linux/i)
	{
	    #$xdpFile="clinuxgnu.xdp";
	    if(-d "$ENV{'TESTRTDIR'}/bin/s390x")
	    {
		$host="linux";
		$perl="$ENV{'TESTRTDIR'}/bin/s390x/$host/TestRTperl";
		$orgxdp="czlinuxgnu.xdp";
	    }
	    else
	    {	#intel redhat & suse
		my $host;

		print &PerlTranslate("ConfigureGcc.pl", "\nLinux configuration for C / C++\n");
		$host="linux";
		$perl="$ENV{'TESTRTDIR'}/bin/intel/$host/TestRTperl";

		my $s=MCheckGcc();
		# Gcc exists and is located
		my ($major_version,$minor_version,$release_number)=split(/\./,$gcc_version);
		print &PerlTranslate("ConfigureGcc.pl", "Status of CheckGcc %1: major=%2 minor=%3 location=%4\n", "%1 is the status, %2 is the Gnu compiler major part of the version, %3 is its minor part of the version and %4 is its location", $s, $major_version, $minor_version, ($gcc_dir?$gcc_dir:"in PATH"));
		$orgxdp="clinuxgnu2_95.xdp" if(($major_version eq "2")&&($minor_version eq "95"));
		$orgxdp="clinuxgnu2_96.xdp" if(($major_version eq "2")&&($minor_version eq "96"));
                $orgxdp="clinuxgnu3_2.xdp" if(($major_version eq "3")&&(($minor_version eq "2")||($minor_version eq "3")||($minor_version eq "4")));
                $orgxdp="clinuxgnu3_2.xdp" if($major_version eq "4");
		print &PerlTranslate("ConfigureGcc.pl", "No TDP match the version of gcc: %1 - Available versions are 2.95.x, 2.96.x, 3.2, 3.3, 3.4 and 4.x\n", "%1 is the Gnu compiler version", $gcc_version) if($orgxdp eq "");
                $orgxdp="clinuxgnu3_2.xdp" if($orgxdp eq ''); #default xdp
		copy("$xmlDir/$orgxdp","$outXmlDir/clinuxgnu.xdp");
	    }
	}
	else
	{
		my $s=MCheckGcc();
		# Gcc exists and is located
		my ($major_version,$minor_version,$release_number)=split(/\./,$gcc_version);
		print &PerlTranslate("ConfigureGcc.pl", "Status of CheckGcc %1: major=%2 minor=%3 location=%4\n", "%1 is the status, %2 is the Gnu compiler major part of the version, %3 is its minor part of the version and %4 is its location", $s, $major_version, $minor_version, ($gcc_dir?$gcc_dir:"in PATH"));
		if($^O =~ /solaris/i)
		{
			print &PerlTranslate("ConfigureGcc.pl", "\nSolaris Gnu configuration for C / C++\n");
			$perl="$ENV{'TESTRTDIR'}/bin/sun4/sunOS5/TestRTperl";
			#$xdpFile="csolgnu.xdp";
			$orgxdp="csolgnu2_95.xdp" if(($major_version eq "2")&&($minor_version eq "95"));
			$orgxdp="csolgnu2_96.xdp" if(($major_version eq "2")&&($minor_version eq "96"));
			$orgxdp="csolgnu3_2.xdp" if(($major_version eq "3")&&(($minor_version eq "2")||($minor_version eq "3")||($minor_version eq "4")));
			$orgxdp="csolgnu3_2.xdp" if($orgxdp eq ''); #default xdp
			copy("$xmlDir/$orgxdp","$outXmlDir/csolgnu.xdp");
		}
		if($^O =~ /hpux/i)
		{
			print &PerlTranslate("ConfigureGcc.pl", "\nHP-UX Gnu configuration for C / C++\n");
			$perl="$ENV{'TESTRTDIR'}/bin/hp700/hpux/TestRTperl";
			#$xdpFile="chpgnu.xdp";
			$orgxdp="chpgnu2_95.xdp" if(($major_version eq "2")&&($minor_version eq "95"));
			$orgxdp="chpgnu2_96.xdp" if(($major_version eq "2")&&($minor_version eq "96"));
			$orgxdp="chpgnu3_2.xdp" if(($major_version eq "3")&&(($minor_version eq "2")||($minor_version eq "3")||($minor_version eq "4")));
			$orgxdp="chpgnu3_2.xdp" if($orgxdp eq ''); #default xdp
		}
		if($^O =~ /aix/i)
		{
			print &PerlTranslate("ConfigureGcc.pl", "\nAIX Gnu configuration for C / C++\n");
			$perl="$ENV{'TESTRTDIR'}/bin/rs6000/aix/TestRTperl";
			#$xdpFile="caixgnu.xdp";
			$orgxdp="caixgnu2_95.xdp" if(($major_version eq "2")&&($minor_version eq "95"));
			$orgxdp="caixgnu2_96.xdp" if(($major_version eq "2")&&($minor_version eq "96"));
			$orgxdp="caixgnu3_2.xdp" if(($major_version eq "3")&&(($minor_version eq "2")||($minor_version eq "3")||($minor_version eq "4")));
			$orgxdp="caixgnu3_2.xdp" if(orgxdp eq ''); #default xdp
			copy("$xmlDir/$orgxdp","$outXmlDir/caixgnu.xdp");
		}
	}
	die &PerlTranslate("ConfigureGcc.pl", "No TDP match the version of gcc: %1\n", "%1 is the Gnu compiler version", $gcc_version) if(($orgxdp eq "") || !(-f "$xmlDir/$orgxdp"));
	my $machine=`uname -m`;
	my $patch64=0;
	if($machine=~m/64/){
		my $xdp64=$orgxdp;$xdp64=~s/\.xdp$/64.xdp/;
		if(-f "$xmlDir/$xdp64"){
			$orgxdp=$xdp64;
		} else {
			$xdp64=~s/64\./_64./;
			if(-f "$xmlDir/$xdp64"){
				$orgxdp=$xdp64 ;
			} else {
				$patch64=1;
			}
		}
	}
	patchXdp("$xmlDir/$orgxdp","$outXmlDir/$xdpFile",$gcc_dir,$patch64);
	system("$perl -I$ENV{'TESTRTDIR'}/lib/perl $ENV{'TESTRTDIR'}/lib/scripts/tdpgen.pl $outXmlDir/$xdpFile  $outTargetsDir");
}

$|=1;
main();
1;
