#!perl -w

#######################################################################################################################################
#
# This script patches testrtinit.sh  with the correct installation directory. It must be provided with the
# installation directory as the first argument.
#
# (c) Copyright 2009 IBM Rational Software Corporation
# All Rights Rerserved
#
#######################################################################################################################################


my $installLocation = join(' ', @ARGV);

my $DoubleBaseInstallationDirectory = $installLocation;
$DoubleBaseInstallationDirectory =~ s,\\,\\\\,g;

#######################################################################################################################################
#
# The list of files to patch with the installation directory
#
#######################################################################################################################################

my @Files = qw(testrtReg.reg);

foreach (@Files)
  {
    my $FileToPatch = $installLocation."/".$_;
    next unless (-f $FileToPatch); # ignore files that don't exist

    # copy the lines into a new file, patching them along the way
    next unless (open (IN, $FileToPatch));
    next unless (open (OUT, '>'.$FileToPatch.'.out'));
    while (<IN>)
	{
	  {
	    s,DIR_TO_PATCH,${DoubleBaseInstallationDirectory},ig;
          }
		print OUT;
		#print DBG ">>> ",$_;
        }
	close (IN);
	close (OUT);

    # Remove the original file
    unlink ($FileToPatch);

    # Rename the new file as the old file
    rename ($FileToPatch.'.out', $FileToPatch);
  }


